# coding: utf-8
import threading
import queue
import requests
import os
import time
from scapy.all import IP, sr, TCP


class CheckProxy:

    def __init__(self, gui):
        self.que = queue.Queue()
        self.run = False
        self.proxy_list = { }
        self.threads = 0
        self.timeout = 2
        self.ttl = 129
        self.type = None
        self.test_url = 'http://google.com'
        self.owned_syn = False
        self.gui = gui
        self._startTime = 0
        self.count = 0
        self.progress = 0
        self.sem = threading.BoundedSemaphore(self.threads)

    def add_proxy(self, proxy_list):
        self.count = 0
        self.proxy_list.clear()
        proxy_list = str(proxy_list).split('\n')
        for proxy in proxy_list:
            proxy = ''.join(proxy.strip().split())
            proxy = proxy.split(':')
            try:
                if proxy[1] in self.proxy_list:
                    self.proxy_list[proxy[1]].append(proxy[0])
                    self.count += 1
                else:
                    self.proxy_list[proxy[1]] = []
                    self.proxy_list[proxy[1]].append(proxy[0])
                    self.count += 1
            except:
                pass

    def start(self):
        self.run = True
        self.sem = threading.BoundedSemaphore(self.threads)
        self.progress = 0
        self._startTime = time.time()

        th = threading.Thread(target=self.is_open)
        th.daemon = True
        th.start()

        th = threading.Thread(target=self.check)
        th.daemon = True
        th.start()


    def check(self):
        while self.run:
            self.gui.update_goods(None)
            if not self.que.empty():
                self.sem.acquire()
                th = threading.Thread(target=self.getPage, args=(self.que.get(), ))
                th.daemon = True
                th.start()

            if self.owned_syn and self.que.empty():
                break
        self.last_check_time = "%.2f" % (time.time() - self._startTime)
        print('Проверка завершена за %s' % str(self.last_check_time))
        self.gui.CheckStop()

    def getPage(self, proxy):
        try:
            proxies = {'http': self.type+'://'+proxy[0]+':'+proxy[1], 'https': self.type+'://'+proxy[0]+':'+proxy[1]}
            r = requests.head(self.test_url, proxies=proxies, timeout=self.timeout)
            if "Location" in r.headers:
                if str(r.headers['Location']).find("google.com") >= 0:
                    res = str(proxy[0])+':'+str(proxy[1])+str(os.linesep)
                    self.gui.update_goods(res)
        except:
            pass
        finally:
            self.progress += 1
            self.gui.update_goods(None)
            self.sem.release()

    def is_open(self):
        for port, ips in self.proxy_list.items():
            try:
                response, unresp = sr(IP(dst=ips, ttl=self.ttl) / TCP(dport=int(port), flags="S"), verbose=0, timeout=self.timeout)
            except:
                continue
            if not self.run:
                break
            for req, resp in response:
                if not self.run:
                    break
                if not resp.haslayer(TCP):
                    pass
                else:
                    tcp_layer = resp.getlayer(TCP)
                    if tcp_layer.flags == 0x12:
                        self.que.put([str(req.dst), port])
                        continue
                self.progress += 1
                self.gui.update_goods(None)

            for i in unresp:
                if not self.run:
                    break
                self.progress += 1
                self.gui.update_goods(None)
        self.owned_syn = True