import sys
from cheker import CheckProxy
from sys import platform
if platform == "linux" or platform == "linux2":
    import ctypes
    ctypes.CDLL('libGL.so.1', ctypes.RTLD_GLOBAL)
from PyQt5.QtGui import QGuiApplication
from PyQt5.QtQml import QQmlApplicationEngine
from PyQt5.QtCore import QObject, pyqtSignal, pyqtSlot

class Cheker(QObject):

    addProxy = pyqtSignal(str, arguments=['addProxy'])
    goodProxy = pyqtSignal(str, arguments=['start'])
    setProgressValue = pyqtSignal(str, arguments=['progress'])
    setMaxProgress = pyqtSignal(str, arguments=['maxprogress'])
    setCheckStop = pyqtSignal(str, arguments=['time'])

    def __init__(self):
        QObject.__init__(self)
        self.checkp = CheckProxy(self)
        self.st = False
        self.proxy_list = ""

    def update_goods(self, proxy):
        self.goodProxy.emit(proxy)
        self.setProgressValue.emit(str(self.checkp.progress))

    def CheckStop(self):
        self.setCheckStop.emit(str(self.checkp.last_check_time))

    @pyqtSlot(str)
    def addProxy(self, arg1):
        self.proxy_list = arg1

    @pyqtSlot(str, str, str, str)
    def start(self, threads="100", timeout="2", ttl=129, type='http'):
        if type == 'https':
            self.checkp.test_url = 'https://google.com'
        else:
            self.checkp.test_url = 'http://google.com'
        self.checkp.type = type
        self.st = True
        self.checkp.ttl = int(ttl)
        self.checkp.owned_syn = False
        self.checkp.threads = int(threads)
        self.checkp.add_proxy(self.proxy_list)
        self.setMaxProgress.emit(str(self.checkp.count))
        self.checkp.timeout = int(timeout)
        self.checkp.start()

    @pyqtSlot()
    def stop(self):
        self.st = False
        self.checkp.run = False

    @pyqtSlot()
    def progress(self):
        pass

if __name__ == "__main__":
    app = QGuiApplication(sys.argv)
    engine = QQmlApplicationEngine()
    checker = Cheker()
    engine.rootContext().setContextProperty("cheker", checker)
    engine.load("mainForm2.qml")
    engine.quit.connect(app.quit)
    sys.exit(app.exec_())