import QtQuick 2.8
import QtQuick.Controls 1.5
import QtQuick.Window 2.3
import QtQuick.Dialogs.qml 1.0

ApplicationWindow {
    visible: true
    property alias mouseArea: mouseArea
    title: qsTr("Proxy Checker V0.5л")
    width: 600
    height: 400
    color: "#363940"
    property var run: false

    MouseArea {
        id: mouseArea
        height: 400
        anchors.rightMargin: 0
        anchors.bottomMargin: 0
        anchors.leftMargin: 0
        anchors.topMargin: 0
        anchors.fill: parent

        Text {
            id: text1
            x: 8
            y: 72
            width: 193
            height: 15
            color: "#27bc38"
            text: qsTr("Input")
            font.family: "Verdana"
            verticalAlignment: Text.AlignTop
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 15
        }

        Text {
            id: text2
            x: 399
            y: 72
            width: 193
            height: 15
            color: "#27bc38"
            text: qsTr("Output")
            verticalAlignment: Text.AlignTop
            font.family: "Verdana"
            font.pixelSize: 15
            horizontalAlignment: Text.AlignHCenter
        }

        ProgressBar {
            id: progbar
            x: 8
            y: 356
            width: 584
            height: 23
            minimumValue: 0
            maximumValue: 100
            orientation: 1
            value: 0
            indeterminate: false
        }

        Text {
            id: text_progress
            x: 10
            y: 358
            width: 193
            height: 15
            color: "#00000F"
            text: qsTr("")
            verticalAlignment: Text.AlignTop
            font.family: "Verdana"
            font.pixelSize: 15
            horizontalAlignment: Text.AlignHCenter
        }

        TextField {
            id: text_threads
            x: 238
            y: 155
            width: 125
            height: 25
            placeholderText: qsTr("Threads: 10")
        }

        ComboBox {
            id: comboBox
            x: 238
            y: 207
            width: 125
            activeFocusOnPress: false
            model: ListModel {
                id: cbItems
                ListElement { text: "http"; color: "Yellow" }
                ListElement { text: "https"; color: "Green" }
                ListElement { text: "socks4"; color: "Blue" }
                ListElement { text: "socks5"; color: "Red" }
            }

            onCurrentIndexChanged: console.debug(currentText + ", " + cbItems.get(currentIndex).color)
        }

        Button {
            id: button
            x: 238
            y: 316
            width: 125
            text: qsTr("Start")
            property var ttl_str: qsTr("129")
            property var threads_str: qsTr("100")
            property var tmt_str: qsTr("2")

            onClicked: {
                if (!run){
                    text_progress.text = qsTr("")
                    if (text_threads.text)
                    {
                        threads_str = text_threads.text
                    }
                    else
                    {
                        threads_str = qsTr("10")
                    }

                    if (timeout.text)
                    {
                        tmt_str = timeout.text
                    }
                    else
                    {
                        tmt_str = qsTr("2")
                    }

                    if (syn_ttl.text)
                    {
                        ttl_str = syn_ttl.text
                    }
                    else
                    {
                        ttl_str = qsTr("129")
                    }

                    cheker.start(threads_str, tmt_str, ttl_str, cbItems.get(comboBox.currentIndex).text)

                    button.text = qsTr("Stop")
                    run = true
                }
                else
                {
                    cheker.stop()
                    button.text = qsTr("Start")
                    run = false
                }
            }
        }

        TextArea {
            id: inproxy
            x: 8
            y: 97
            width: 193
            height: 244
            onTextChanged: {
                // Invoke the calculator slot to sum the numbers
                cheker.progress()
                cheker.addProxy(inproxy.text)
            }
        }

        TextArea {
            id: oproxy
            x: 399
            y: 97
            width: 193
            height: 244
        }

        TextField {
            id: timeout
            x: 238
            y: 256
            width: 125
            height: 25
            placeholderText: qsTr("Timeout: 2s")
        }

        Image {
            id: image
            x: 8
            y: 8
            width: 193
            height: 58
            source: "logo.gif"
        }

        TextField {
            id: syn_ttl
            x: 238
            y: 108
            width: 125
            height: 25
            placeholderText: qsTr("TTL: 129")
        }

        Connections {
            target: cheker

            onSetMaxProgress: {
                progbar.maximumValue = maxprogress
            }

            onSetCheckStop: {
                button.text = qsTr("Start")
                text_progress.text = qsTr("Time: "+time+" seconds")
                run = false
            }

            onSetProgressValue: {
                progbar.value = progress
            }

            onGoodProxy: {
                oproxy.text = oproxy.text+start
            }
        }
    }
}